<?php

/*
 * Copyright (C) 2010 Julien VAUBOURG / Sébastien BADIA
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

require_once("header.php");

try {
	// Récupération du nom de l'entrée
	$nom = urlencode($_GET["nom"]);

	if(empty($nom))
		throw new Microsoft("Vous devez préciser un nom de page.");

	if(!isset($_GET["vdate1"]) || !isset($_GET["vdate2"]))
		throw new Microsoft("Vous devez préciser deux dates de version.");

	// Récupération de l'identifiant de l'entree associée au nom passé en paramétre
	$entrees = Mysql::get()->query("SELECT id FROM ".TABLE_PREFIX."entree WHERE nom=".Mysql::get()->quote($nom)." LIMIT 1");
	$idEntree = $entrees->fetch(PDO::FETCH_COLUMN);

	if(empty($idEntree))
		throw new Microsoft("Page inexistante.");

	// Trie des deux versions de l'entrée passée passées en paramétres, afin de pouvoir comparer la plus
	// récente avec la plus ancienne.
	$vdate1 = $_GET["vdate1"] < $_GET["vdate2"] ? $_GET["vdate1"] : $_GET["vdate2"];
	$vdate2 = $_GET["vdate1"] < $_GET["vdate2"] ? $_GET["vdate2"] : $_GET["vdate1"];

	$vdate1Sql = Mysql::get()->quote($vdate1);
	$vdate2Sql = Mysql::get()->quote($vdate2);

	// Récupération de l'id des deux pages correspondantes aux deux versions de l'entree
	$pages = Mysql::get()->query("SELECT id FROM ".TABLE_PREFIX."page WHERE entree=$idEntree AND (datemodif=$vdate1Sql OR datemodif=$vdate2Sql)");

	$idPage1 = $pages->fetch(PDO::FETCH_COLUMN);
	$idPage2 = $pages->fetch(PDO::FETCH_COLUMN);

	// Instantiation des deux versions
	$page1 = new Page($idPage1);
	$page2 = new Page($idPage2);

	// Récupération des ajouts, changements et suppression entre les deux versions
	$diff = $page1->diffWith($page2);

	$tpl = file_get_contents("templates/diff.tpl");

	$tpl = preg_replace("/\<TPL\:NOM\>/", urldecode($nom), $tpl, 1);
	$tpl = str_replace(
			Array("<TPL:DIFF>", "<TPL:NOM>", "<TPL:VDATE1>", "<TPL:VDATE2>"),
			Array($diff, $nom, truncdate($vdate1, 2), truncdate($vdate2, 2)),
		$tpl);

	echo $tpl;

} catch(Microsoft $e) {
	echo $e;
}

require_once("footer.php");

?>
