<?php

/*
 * Copyright (C) 2010 Julien VAUBOURG / Sébastien BADIA
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
<head>
<title>WIKI - Installation</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<link type="text/css" rel="stylesheet" href="install.css" />
<script type="text/javascript">
	function verifPwd() {
		if(document.getElementById("pwd01").value != document.getElementById("pwd02").value ||
		   document.getElementById("pwd11").value != document.getElementById("pwd12").value ||
		   document.getElementById("pwd21").value != document.getElementById("pwd22").value ||
		   document.getElementById("pwd31").value != document.getElementById("pwd32").value) {
			alert("Le mot de passe de confirmation doit être identique\nà la valeur du champ de même type le précédent.");
			return false;
		}

		return true;
	}
</script>
</head>

<body>

<?php

// Vérification de la possibilité d'écrire le XML dans le dossier config/
if(!is_writable("../config")) {

	// On tente de chmoder à la main
	$write = chmod("../config", 0777);

	// Si PHP n'a pas pu changer les droits, on demande à l'utilisateur de le faire lui-même
	if(!$write) {
		echo '<div id="erreur">'."\n";
		echo "<p>Le répertoire <em>config/</em> doit être accessible en écriture.</p>\n";
		echo "<p>PHP ne semble pas avoir les droits nécessaire pour en changer les droits.</p>\n";
		echo "<p>Veuillez donner les droits d'écriture à ce répertoire, disponible à la racine du projet</p>\n";
		echo "<p>(au plus simple : <em>chmod 777 config</em>).</p>\n";
		echo '<input type="button" onclick="location.reload(true)" value="Rafraîchir" />'."\n";
		echo "</div>";
	}

// Si le fichier .lock existe, c'est que l'installation a déjà été effectuée, pas question d'écraser
// les paramétres sans action préalable sur le serveur.
} elseif(file_exists("../config/.lock")) {
	echo '<div id="erreur">'."\n";
	echo "<p>L'installation du wiki a déjà été effectuée.</p>\n";
	echo "<p>Pour forcer la réinstallation, supprimez le fichier <em>config/.lock</em><br />\n";
	echo "ainsi que le fichier <em>config/config.xml.php</em></p>\n";
	echo "</div>";

// La licence n'a pas été acceptée
} elseif(isset($_GET["license"])) {
	echo '<div id="erreur">'."\n";
	echo "<p>Vous devez accepter la licence pour installer ce logiciel.</p>\n";
	echo '<input type="button" onclick="window.location=\'index.php\'" value="Reprendre" />'."\n";
	echo "</div>";

// Un champ est resté vide
} elseif(isset($_GET["emptyField"])) {
	echo '<div id="erreur">'."\n";
	echo "<p>Tous les champs sont obligatoires !</p>\n";
	echo '<input type="button" onclick="window.location=\'index.php\'" value="Reprendre" />'."\n";
	echo "</div>";

} else {

?>
<form action="install.php" method="post" onsubmit="return verifPwd()">
<div>
	<h1>Installation du wiki</h1>

	<fieldset> <legend>Configuration</legend>

		<fieldset> <legend>Générale</legend>
			<label><span>Nom du wiki :</span> <input type="text" name="wiki_name" value="DOSCH's wiki" /></label>
		</fieldset>

		<fieldset> <legend>Administrateur</legend>
			<label><span>Nom :</span> <input type="text" name="wiki_admin_name" value="DOSCH" /></label>
			<label><span>Prénom :</span> <input type="text" name="wiki_admin_fname" value="Philippe" /></label>
			<label><span>Courriel :</span> <input type="text" name="wiki_admin_mail" value="admin@dosch.com" /></label>
			<label><span>Pseudo :</span> <input type="text" name="wiki_admin_pseudo" value="admin" /></label>
			<label><span>Mot de passe :</span> <input type="password" name="wiki_admin_pwd1" id="pwd01" /></label>
			<label><span>Confirmer :</span> <input type="password" name="wiki_admin_pwd2" id="pwd02" /></label>
		</fieldset>

		<fieldset> <legend>Base de données MySQL</legend>
			<label class="create"><input type="checkbox" name="create_base" value="1" checked="checked" />Créer la base (si elle n'existe pas)</label>
			<label><span>Hôte :</span> <input type="text" name="db_host" value="localhost" /></label>
			<label><span>Nom de la base :</span> <input type="text" name="db_dbname" value="wiki" /></label>
			<label><span>Préfixe des tables :</span> <input type="text" name="db_prefix" value="wiki_" /></label>

			<fieldset> <legend>Utilisateur root existant (au min. CREATE, INSERT et GRANT)</legend>
				<div>
					Le wiki fonctionne avec deux utilisateurs aux droits limités.<br />
					Pour éventuellement les créer, éventuellement ajouter la base de données, et écrire les tables initiales (si elles n'existent pas), l'installeur nécessite un utilisateur root ayant les pleins droits sur le S.G.B.D. Les paramétres de cet utilisateur ne seront stockés à aucun endroit et ne serviront que pour cette installation.
				</div>
				<label><span>Nom :</span> <input type="text" name="db_root_name" value="root" /></label>
				<label><span>Mot de passe :</span> <input type="password" name="db_root_pwd1" id="pwd11" /></label>
				<label><span>Confirmer :</span> <input type="password" name="db_root_pwd2" id="pwd12" /></label>
			</fieldset>

			<fieldset> <legend>Utilisateur classique (SELECT et INSERT + UPDATE sur quelques colonnes, sur la base)</legend>
				<label class="create"><input type="checkbox" name="create_user" value="1" checked="checked" />Créer l'utilisateur (ajoute les droits si l'utilisateur existe)</label>
				<label><span>Nom :</span> <input type="text" name="db_user_name" value="wiki_user" /></label>
				<label><span>Mot de passe :</span> <input type="password" name="db_user_pwd1" id="pwd21" /></label>
				<label><span>Confirmer :</span> <input type="password" name="db_user_pwd2" id="pwd22" /></label>
			</fieldset>

			<fieldset> <legend>Utilisateur admin (SELECT, INSERT, UPDATE, CREATE et DELETE sur la base)</legend>
				<label class="create"><input type="checkbox" name="create_admin" value="1" checked="checked" />Créer l'utilisateur (ajoute les droits si l'utilisateur existe)</label>
				<label><span>Nom :</span> <input type="text" name="db_admin_name" value="wiki_admin" /></label>
				<label><span>Mot de passe :</span> <input type="password" name="db_admin_pwd1" id="pwd31" /></label>
				<label><span>Confirmer :</span> <input type="password" name="db_admin_pwd2" id="pwd32" /></label>
			</fieldset>

			<label><input type="checkbox" name="samples" value="1" checked="checked" />Insérer des données d'exemple</label>
		</fieldset>

		<fieldset id="license"> <legend>License</legend>
			<textarea cols="80" rows="5" readonly="readonly"><?php include("license.txt") ?></textarea>
			<label><input type="checkbox" name="license_ok" value="1" /> J'accepte les conditions d'utilisation</label>
		</fieldset>

		<div><input type="submit" value="Installer" class="bouton" /></div>
	</fieldset>

	<address>Conception : Sébastien BADIA et Julien VAUBOURG</address>
</div>
</form>

<?php } ?>

</body>
</html>
