<?php

/*
 * Copyright (C) 2010 Julien VAUBOURG / Sébastien BADIA
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

require_once("header.php");

try {
	if(!CONNECTED)
		throw new Microsoft("Vous devez être connecté pour créer une nouvelle version.");

	if(!empty($_POST)) {
		$page = null;

		// Nom de la page à créer : le nom correspond à l'entrée en rapport
		// qui sera également créée si nécessaire. Sinon c'est simplement une nouvelle
		// page et donc nouvelle version.
		$nom = urlencode($_POST["nom"]);

		try {
			// Récupératin de l'identifiant de l'entrée correspondant au nom
			$entree = Mysql::get()->query("SELECT id FROM ".TABLE_PREFIX."entree WHERE nom=".Mysql::get()->quote($nom)." LIMIT 1");
			$idEntree = $entree->fetch(PDO::FETCH_COLUMN);

			if(empty($idEntree))
				throw new Microsoft("La page n'existe pas.");

			// Création d'un enregistrement vide dans la table page, ayant pour entree
			// l'id de celle qui correspondant au nom, et instanciation de celui-ci.
			$page = Page::add(USER, $idEntree);

		// Si une exception personnalisée est attrapée, c'est qu'il n'y a aucune entree pour ce nom.
		// La création de page sans entree indiquée la fera créer.
		} catch(Microsoft $e) {
			$page = Page::add(USER);
		}

		// Initialisation des champs du nouvel enregistrement, qui s'enristreront dans base à la destruction
		// de son instanciation.
		$page->entree->nom->value = htmlspecialchars($nom, ENT_NOQUOTES, "UTF-8");
		$page->texte->value = htmlspecialchars($_POST["texte"], ENT_NOQUOTES, "UTF-8");
		$page->datemodif->value = date("Y-m-d H:i:s");

		header("Location: view.php?nom=$nom");
	}

} catch(Microsoft $e) {
	echo $e;
}

require_once("footer.php");

?>
