<?php

/*
 * Copyright (C) 2010 Julien VAUBOURG / Sébastien BADIA
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

require_once("header.php");

try {
	// Récupération de l'identifiant de l'entree et l'auteur à partir du nom
	$entree = Mysql::get()->query("SELECT id FROM ".TABLE_PREFIX."entree WHERE nom=".Mysql::get()->quote($_GET["nom"])." LIMIT 1");
	list($idEntree, $userEntree) = $entree->fetch(PDO::FETCH_NUM);

	if(empty($idEntree))
		throw new Microsoft("La page n'existe pas.");

	if($userEntree != USER && !ADMIN)
		throw new Microsoft("Vous n'êtes pas autorisé à rétablir cette entrée.");

	if(!empty($_GET["nom"]) && !empty($_GET["vdate"])) {

		// Suppression de toutes les pages (version) concernant l'entree dont la date de modification est supérieure à la
		// date de la version qu'on cherche à restaurer (qui sera donc la page la plus récente et donc la dernière version)
		Mysql::get()->query("DELETE FROM ".TABLE_PREFIX."page WHERE entree=$idEntree AND datemodif > ".Mysql::get()->quote($_GET["vdate"]));

		header("Location: view.php?nom=".urlencode($_GET["nom"]));
		exit();
	}

} catch(Microsoft $e) {
	echo $e;
}

require_once("footer.php");

?>
