<?php

/*
 * Copyright (C) 2010 Julien VAUBOURG / Sébastien BADIA
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

require_once("header.php");

try {
	// Le nom correspond à celui de l'entrée concernée
	// La date correspond à celle de la page (version - qui concerne cette entrée) qu'il faut afficher
	$nom = isset($_GET["nom"]) ? urlencode($_GET["nom"]) : "Accueil";
	$vdate = isset($_GET["vdate"]) ? urldecode($_GET["vdate"]) : null;

	// On récupére l'idenfifiant de l'entrée concernée
	$entrees = Mysql::get()->query("SELECT id FROM ".TABLE_PREFIX."entree WHERE nom=".Mysql::get()->quote($nom)." LIMIT 1");
	$idEntree = $entrees->fetch(PDO::FETCH_COLUMN);

	// Si aucune entrée ne correspond au nom demandé, on redirige vers la page d'édition (et donc création,
	// dans ce cas).
	if(empty($idEntree)) {
		header("Location: edit.php?nom=$nom");
		exit();
	}

	// Recupération de tous les id et date de pages concernant cette entrée
	$pages = Mysql::get()->query("SELECT id, datemodif FROM ".TABLE_PREFIX."page WHERE entree=$idEntree ORDER BY datemodif DESC");
	$pagesVersions = $pages->fetchAll(PDO::FETCH_OBJ);

	$versions = null;
	$idCurVersion = null;

	// Formation de la liste de liens des différentes versions (pages) de l'entrée
	foreach($pagesVersions AS $version) {

		// Si c'est la dernière version de cette entrée (date de modif. la plus récente), on met le lien en valeur
		if((is_null($vdate) && is_null($versions)) || $vdate == $version->datemodif) {
			$versions .= '<li id="curVersion">'.truncDate($version->datemodif, 2)."</li>\n";
			$idCurVersion = $version->id;
		} else
			$versions .= "<li><a href=\"view.php?nom=$nom&amp;vdate=".urlencode($version->datemodif).'">'.truncDate($version->datemodif, 2)."</a> (<a href=\"diff.php?nom=$nom&amp;vdate1=<VDATE_CURVERSION>&amp;vdate2=".urlencode($version->datemodif)."\" class=\"lienDiff\" title=\"Comparer avec cette version\">diff</a>)</li>\n";
	}

	if(is_null($idCurVersion))
		throw new Microsoft("Page ou version introuvable.");

	// Instanciation de la page de la version qu'on cherche à afficher (selon la date de version)
	$page = new Page($idCurVersion);

	$versions = str_replace("<VDATE_CURVERSION>", urlencode($page->datemodif->value), $versions);
	$page = str_replace("<TPL:VERSIONS>", $versions, $page);

	echo $page;

} catch(Microsoft $e) {
	echo $e;
}

require_once("footer.php");

?>
